Imports System.Security.Principal

Module Module1

    Sub Main()
        ShowUserInfo()
        ShowUserRoles()
        Console.ReadLine()
    End Sub

    Public Sub ShowUserInfo()
        Dim ARole As WindowsPrincipal = New WindowsPrincipal(WindowsIdentity.GetCurrent())
        Console.WriteLine(ARole.Identity.Name & "...")
        If ARole.IsInRole("BUILTIN\Administrators") Then
            Console.WriteLine("is an administrator")
        End If
        If ARole.IsInRole("BUILTIN\Users") Then
            Console.WriteLine("is a user ")
        End If
    End Sub

    Public Sub ShowUserRoles()
        Dim roles() As String
        Dim CurrentIdentity As WindowsIdentity = WindowsIdentity.GetCurrent
        Dim roleobject As Object
        Try
            roleobject = GetType(WindowsIdentity).InvokeMember("GetRoles", Reflection.BindingFlags.InvokeMethod Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.NonPublic, Nothing, CurrentIdentity, Nothing)
        Catch ex As Exception
            Console.WriteLine("Error occurred accessing the GetRoles method - is your application configuration file correct?")
        End Try
        roles = CType(roleobject, String())

        Dim role As String
        Console.WriteLine("User " & CurrentIdentity.Name & " belongs to:")
        For Each role In roles
            Console.WriteLine(role)
        Next

    End Sub
End Module
