using System;
using System.IO;
using FileSecurityCS;
using System.Messaging;

namespace FileSecurityCSTest
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
        StreamWriter fw = new StreamWriter("e:\\test.txt", false);
        fw.WriteLine("Test file");
        fw.Close();

        FileSystemAccessControlEntry ace = new FileSystemAccessControlEntry(new Trustee("Administrators"));
        ace.GenericAccessRights = GenericAccessRights.All;
        ace.EntryType = AccessControlEntryType.Set;
        FileSystemAccessControlList acl = new FileSystemAccessControlList();
        acl.Add(ace);

        FileSystemAccessControlEntry ace2 = new FileSystemAccessControlEntry(new Trustee("Everyone"));
        ace2.GenericAccessRights = GenericAccessRights.Read;
        ace2.EntryType = AccessControlEntryType.Set;
        acl.InheritanceSettings = FileSystemInheritanceType.BlockInheritance;

        acl.Add(ace2);

        acl.SetFileSecurity("e:\\test.txt");
		}
	}
}
